function DisplayWebElement(ContentElement){
    var self = this; self.name = "DisplayWebElement"; // MANDATORY

    this.reference = -1;
    this.type = -1;
    this.switch = 0;
    this.relative_path = false;
    this.force_http_source = false;
    this.die = true;
    this.time_to_die = 1500;

    this.loaded = false;

    this.x = 0;
    this.y = 0;
    this.w = "100%";
    this.h = "100%";
    this.z = 1;

    this.ui = false;
    this.uiTimer = null;
    this.uiStartTime = 0;

    this.source = ContentElement.getSource();
    this.duration = ContentElement.getDuration();
    this.relative_path = ContentElement.relative_path;
    this.path = ContentElement.path;
    this.tag = "";
    this.timer = null;

    this.restart_on_activity = false;
    
    //this.content_api = new ApiContentConnector();

    this.update = function(ContentElement){
        self.content = ContentElement;
        self.source = ContentElement.getSource();
        self.duration = ContentElement.getDuration();
        self.relative_path = ContentElement.relative_path;
        self.path = ContentElement.path;
    };
    
    this.createIframe = function(layer){
      try{
        $("#"+self.tag).hide();
        self.clear_source();
      }catch(e){
        self.log("TAG does not exist");
      }
      if(self.platform == "CHROMEOS"){
        $(".stage").append('<webview class="player-media" id="'+self.tag+'" src=""></webview>');
      }else{
        $(".stage").append('<iframe class="player-media" id="'+self.tag+'" src=""></iframe>');
      }
    };

    this.load = function(){
        self.loaded = false;
        self.createIframe();
        $(self.content_api).on("ApiContentChangeDuration",self.onApiChangeDuration);
        $(self.content_api).on("ApiContentFinish",self.onApiContentFinish);
        self.log("Load on tag : "+$("#"+self.tag).attr("id"));
        if(self.platform == "CHROMEOS"){
            $("#"+self.tag).one("loadstart",self.onElementLoadComplete);
            $("#"+self.tag).one("loadabort",self.onElementLoadError);
            $("#"+self.tag).attr("src",self.path);
            self.log("Loading : "+self.path+" on tag : "+self.tag);
            //$(self).trigger("DisplayElementLoaded");
        }else{
          $("#"+self.tag).one("load",self.onElementLoadComplete);
          $("#"+self.tag).one("error",self.onElementLoadError);
          $("#"+self.tag).attr("src",self.path);
          self.log("Loading : "+self.path+" on tag : "+self.tag);
        }
        $("#"+self.tag).css('visibility','hidden');
    };

    this.onApiChangeDuration = function(e,command){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.duration) !== "undefined"){
                if(!isNaN(command.params.duration)){
                    self.log("Api Content wants to change duration to : "+command.params.duration);
                    clearTimeout(self.timer);
                    self.timer = setTimeout(self.timeout,command.params.duration*1000);
                    if(typeof(command.params.restart_on_activity) !== "undefined"){
                        self.restart_on_activity = command.params.restart_on_activity;
                    }else{
                        self.restart_on_activity = false;
                    }
                }
            }else{
                self.notifyError(self.ERROR['DISPLAY_WEB_ELEMENT']+2,self.name+": Function onApiChangeDuration() failed : not valid file data");
            }
        }else{
            self.notifyError(self.ERROR['DISPLAY_WEB_ELEMENT']+2,self.name+": Function onApiChangeDuration() failed : not valid file data");
        }
    };

    this.onApiContentFinish = function(e){
         self.log("Api Content wants to finish now ! ");
         self.timeout();
    };

    this.onUserActivity = function(e){
        if(self.restart_on_activity){
            self.log("User activity restarted duration : "+self.duration);
            clearTimeout(self.timer);
            self.timer = setTimeout(self.timeout,self.duration*1000);
        }
    };

    this.onElementLoadComplete = function(event){
        if(typeof($("#"+self.tag)) !== "undefined"){
            if(typeof($("#"+self.tag)[0]) !== "undefined"){
                if(typeof($("#"+self.tag)[0].contentWindow) !== "undefined"){
                    $("#"+self.tag)[0].contentWindow.addEventListener("mousedown",self.onMouseDown,false);
                    $("#"+self.tag)[0].contentWindow.addEventListener("message",self.onMessageRecieve,false);
                }
            }
        }
        self.playstatus = "STOP";
        self.log("Loaded on tag : "+self.tag);
        self.loaded = true;
        $(self).trigger("DisplayElementLoaded");
    };

    this.onElementLoadError = function(event){
        self.notifyError(self.ERROR['DISPLAY_WEB_ELEMENT']+1,self.name+": Function onElementLoadSourceError() failed : could not load :"+self.path);
        self.disable();
        self.playstatus = "INVALID";
        $(self).trigger("DisplayElementError");
        self.log("Error on tag : "+self.tag);
    };

    this.disable = function(){
        if(typeof($("#"+self.tag)) !== "undefined"){
            $("#"+self.tag).off("load",self.onElementLoadComplete);
            $("#"+self.tag).off("error",self.onElementLoadError);
            $("#"+self.tag).attr("src","");
        }
        self.log("Disable : "+self.tag);
    };

    this.play = function(){
        self.started = true;
        $("#"+self.tag).off("load",self.onElementLoadComplete);
        self.log("Play : "+self.reference+" with duration : "+self.duration+" on tag : "+self.tag);
        if(self.duration > 0){
            self.timer = setTimeout(self.timeout,self.duration*1000);
        }
        $("#"+self.tag).show();
        /// TODO : FIX Smartcontents
        //$("#"+self.tag).attr("src",$("#"+self.tag).attr("src")); // NEEDED FOR SMARTCONTENT RESIZE
        $(self).trigger("DisplayElementPlay");
        $("#"+self.tag).css('visibility','visible');
        self.uiStartTime = Date.now();
    };

    this.timeout = function(){
        if(self.tag == "iframe-primary-0" || self.tag == "iframe-secondary-0"){
          self.log("Yes, timeout");
        }
        clearTimeout(self.timer);
        if(self.die){
            self.playstatus = "STOP";
            $(self).trigger("DisplayElementFinish");
            self.log("Timeout on tag : "+self.tag);
        }
    };

    this.connect = function(ui){
        /*
        self.ui = ui;
        if(self.ui){
          self.uiTimer = setInterval(self.updateTime,200);
          self.ui.loadVolume();
        }
        */
    };

    this.disconnect = function(){
        /*
        clearInterval(self.uiTimer);
        if(self.ui){
            self.ui.unloadTime();
            self.ui.unloadVolume();
        }
        self.ui = null;
        */
    };

    this.updateTime = function(){
        if(self.ui){
            var current = (Date.now() - self.uiStartTime) / 1000;
            self.ui.loadTime(current,self.duration);
        }
    };

    this.clear_source = function(){
        clearInterval(self.uiTimer);
        $(self.content_api).off("ApiContentChangeDuration",self.onApiChangeDuration);
        $(self.content_api).off("ApiContentFinish",self.onApiContentFinish);
        if(typeof($("#"+self.tag)) !== "undefined"){
            if(typeof($("#"+self.tag)[0]) !== "undefined"){
                if(typeof($("#"+self.tag)[0].contentWindow) !== "undefined"){
                    $("#"+self.tag)[0].contentWindow.removeEventListener("mousedown",self.onMouseDown);
                    $("#"+self.tag)[0].contentWindow.removeEventListener("message",self.onMessageRecieve);
                }
            }
            $("#"+self.tag).attr("src","about:blank");
        }
        try{
          $("#"+self.tag).remove();
        }catch(e){
          self.log("TAG does not exist");
        }
    };

    this.onMouseDown = function(e){
      var clickEvent = document.createEvent('MouseEvents');
      clickEvent.initEvent("mousedown", false, false);
      window.dispatchEvent(clickEvent);
      clickEvent = null;
    };
    
    this.onMessageRecieve = function(e){
      var original = e;
      self.log("API Content Event on "+self.tag+" : "+original.data+" source : "+original.source+" origin : "+original.origin);
      $(window).trigger("ApiContentEvent",[original,self.tag,self]);
      original = null;
    };

    // COMMON
    this.vanish = function(){
        self.started = false;
        $("#"+self.tag).hide();
        $("#"+self.tag).css("z-index","0");
        $("#"+self.tag).css("visibility","hidden");
        $(window).trigger("ApiContentUnregister",[self.tag]);
        self.log("hide on tag : "+self.tag);
        //self.clear_source();
    };

    this.destroy = function(time){
        self.loaded = false;
        clearTimeout(self.timer);
        self.disconnect();
        if(typeof(time) === 'undefined'){ time = 0; }
        if(time == 0){
            self.vanish();
            self.clear_source();
        }else{
            setTimeout(function(){
                self.vanish();
                self.clear_source();
            },time);
        }
        self.disable();
        self.log(self.reference+" destroyed ... on tag : "+self.tag);
    };

    this.modifyViewer = function(x,y,w,h,z){
        if(typeof(z) === 'undefined'){z=1;}
        self.x = x;
        self.y = y;
        self.w = w;
        self.h = h;
        self.z = z;
    };

    this.setViewer = function(){
        $("#"+self.tag).css("left",self.x);
        $("#"+self.tag).css("top",self.y);
        $("#"+self.tag).css("width",self.w);
        $("#"+self.tag).css("height",self.h);
        $("#"+self.tag).css("z-index",self.z);
    };

}
DisplayWebElement.prototype = new SystemController();
