'use strict';

var player = false;

var beat_timer = false;
var service_timer = false;

var last_mouse_pos_x = 0;
var last_mouse_pos_y = 0;
var lastUserActivity = 0;
var beat_timer = false;

function adaptPlayerWindowSize(){
  if(player){
    if(player.config){
      var is_fixed_size = false;
      var screen = player.config.getScreenConfig();
      if(screen.w == "100%"){
        screen.w = window.innerWidth;
      }else{
        is_fixed_size = true;
      }
      if(screen.h == "100%"){
        screen.h = window.innerHeight;
      }else{
        is_fixed_size = true;
      }
      if(is_fixed_size){
        player.OS.setMaxWindowDesktop(screen);
        player.setPlayerWindow();
      }else{
        player.OS.setMaxWindowDesktop();
        player.setPlayerWindow();
      }
    }
  }
}


$(document).ready(function(){
    if(!service_timer){
        service_timer = setInterval(service,20000);
    }

    var child = window.location.search;
    child = parseInt(child.substring(1,child.length));
    if(!isNaN(child)){
      if(!player){
          player = new PlayerController(child);
          $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
          player.init();
          //adaptPlayerWindowSize();
      }
    }
});

function beat(){
    if(!player.OS.window_showing){
        var mouse_pos = player.OS.getMousePos();
        if(mouse_pos){
          console.log(mouse_pos);
          if(mouse_pos.x != last_mouse_pos_x || mouse_pos.y != last_mouse_pos_y){
            last_mouse_pos_x = mouse_pos.x;
            last_mouse_pos_y = mouse_pos.y;
            lastUserActivity = parseInt(player.getDate().getTime()/1000);
          }
        }
        var playerMode = player.config.getMode();
        var playerModeTime = player.config.getModeTime();
         //console.log("NWJS Window beat! mode : "+playerMode+" : "+playerModeTime);
        if(playerMode == "1"){ // SCREENSAVER
            var now = parseInt(player.getDate().getTime()/1000);
            console.log("Now : "+now+" Last Activity : "+lastUserActivity);
            var spentTimeSinceLastActivity =  now - lastUserActivity;
            console.log("Spent Time : "+spentTimeSinceLastActivity);
            if(spentTimeSinceLastActivity > playerModeTime){
                console.log("Show Window !");
                if(!player.OS.window_showing){
                  player.OS.recover();
                  player.OS.togglePlayerMenu();
                }
            }
        }
    }
}

function service(){
    player.service();
    var playerMode = player.config.getMode();
    if(playerMode != "1" && !player.OS.player_paused_by_user){
        player.OS.recover();
    }
    adaptPlayerWindowSize();
}


function onPlayerDataLoaded(){
  if(!beat_timer){
      beat_timer = setInterval(beat,1000);
      
      $(window).keypress(function(event){
          //console.log("KeyPress Code = "+event.which+" Shifted = "+self.keyboardShifted);
          lastUserActivity = parseInt(player.getDate().getTime()/1000);
      });
      $(window).on("mousemove",function(event) {
          //console.log("Mouse MOVE !!");
          lastUserActivity = parseInt(player.getDate().getTime()/1000);
      });
  }
  adaptPlayerWindowSize();  
}
